###########################################################################
#
#   Copyright (c) 2000 Morten W. Petersen <morten@esol.no>
#	Copyright (c) 2000 Erik Enge <erik@esol.no>
#	Copyright (c) 2000 Thingamy Ltd.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
#    MA 02111-1307 USA
#
#
###########################################################################

# $Author: morten $
# $Revision: 1.2 $


__doc__ = 'Documentation string.'
__version__ = '0.1.0'

from Globals import HTMLFile
from Globals import Persistent
from Globals import default__class_init__
import Acquisition
import AccessControl.Role
import OFS.Folder
import note
import base_item


manage_add_note_sort_form = HTMLFile('note_sort_add', globals())


def manage_add_note_sort(self, id='', title='', description='',
			REQUEST=None, RESPONSE=None):
	"Add an instance of the note_sort class"

	if not id:

		id = str(self.get_unique_id())

	self._setObject(id, note_sort(id, title, description))

	if RESPONSE is not None:

		RESPONSE.redirect(self.absolute_url())

		


class note_sort(
	OFS.Folder.Folder,
	Persistent,
	Acquisition.Implicit,
	AccessControl.Role.RoleManager,
	base_item.base_item
	):
	"Documentation string"

	meta_type = 'NoteSort'
	icon = 'misc_/Transform/Folder_icon.gif'

	_properties = (
		{'id':'title', 'type':'string'},
		{'id':'description', 'type':'text'},
		)

	meta_types = (
		{'name':'Note', 'action':'manage_add_note_form'},
		)

	manage_add_note_form = note.manage_add_note_form
	manage_add_note = note.manage_add_note

	__ac_permissions__ = (
		('View management screens',
		 ('manage_tabs', 'manage_main')),
		('Change Permissions',
		 ('manage_access',)),
		('Add Note',
		 ('manage_addNote', 'manage_addNoteForm')),
		('View NoteSorts',
		 ('',)),
		)

	index_html = HTMLFile('note_sort_index', globals())


	def get_number_of_notes(self):
		"""Returns the number of notes this note sort contains."""

		return len(self.objectIds('Note'))


	def __init__(self, id, title, description=''):
		"Initialize the class instance"

		self.id = id
		self.title = title
		self.description = description


default__class_init__(note_sort)

