###########################################################################
#
#   Copyright (c) 2000 Morten W. Petersen <morten@esol.no>
#	Copyright (c) 2000 Thingamy Ltd.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
#    MA 02111-1307 USA
#
#
###########################################################################

# $Author: morten $
# $Revision: 1.0 $

__doc__ = 'Documentation string.'
__version__ = '0.1.0'

from Globals import HTMLFile
from Globals import Persistent
from Globals import default__class_init__
import Acquisition
import AccessControl.Role
import OFS.Folder
import Products
import personal_container
import base_item

personal_folder_add_redirect = HTMLFile('personal_folder_add_redirect', globals())
manage_add_personal_folder_form = HTMLFile('personal_folder_add', globals())

def manage_add_personal_folder(self, id, title, description, REQUEST=None):
    "Add an instance of the PersonalFolder class"

    self._setObject(id, personal_folder(id, title, description))

    if REQUEST is not None:

	REQUEST.RESPONSE.redirect(self.absolute_url())


class personal_folder(
	Products.ZCatalog.CatalogAwareness.CatalogAware,
	OFS.Folder.Folder,
	Persistent,
	Acquisition.Implicit,
	AccessControl.Role.RoleManager,
	base_item.base_item
	):
	"Documentation string"

	meta_type = 'PersonalFolder'
	product_name = 'PersonalFolder'
	icon = 'misc_/PersonalFolder/Folder_icon.gif'
	default_catalog = 'Catalog'

	_properties = (
		{'id':'title', 'type':'string'},
		{'id':'description', 'type':'text'},
		)

	__ac_permissions__ = (
		('View management screens',
		 ('manage_tabs', 'manage_main')),
		('Change Permissions',
		 ('manage_access',)),
		('View PersonalFolders',
		 ('',)),
		)

	meta_types = (
			{'name':'PersonalContainer', 'action':'manage_add_personal_container_form'},
			)

	manage_add_personal_container_form = personal_container.manage_add_personal_container_form
	manage_add_personal_container = personal_container.manage_add_personal_container

	index_html = HTMLFile('personal_folder_index', globals())

	def __init__(self, id, title='', description=''):
		"Initialize the class instance"

		self.id = id
		self.title = title
		self.description = description
		self.index_object()

		self.counter = 0


	def get_unique_id(self):
		"""Returns a unique identifier."""

		try:

			return self.getParentNode().get_unique_id()

		except AttributeError:

			self.counter = self.counter + 1
			return self.counter



default__class_init__(personal_folder)

